## mingw-w64-zlib-ng-2.2.5-1.src.tar.zst

=== test/benchmarks/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

include(FetchContent)

if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
endif()
if(NOT DEFINED CMAKE_CXX_STANDARD_REQUIRED)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
if(NOT DEFINED CMAKE_CXX_EXTENSIONS)
    set(CMAKE_CXX_EXTENSIONS ON)
endif()

# Search for Google benchmark package
find_package(benchmark QUIET)
if(NOT benchmark_FOUND)
    # Fetch google benchmark source code from official repository
    set(BENCHMARK_ENABLE_TESTING OFF)

    # Allow specifying alternative Google benchmark repository
    if(NOT DEFINED GBENCHMARK_REPOSITORY)
        set(GBENCHMARK_REPOSITORY https://github.com/google/benchmark.git)
    endif()
    if(NOT DEFINED GBENCHMARK_TAG)
        set(GBENCHMARK_TAG v1.7.1)
    endif()

    FetchContent_Declare(benchmark
        GIT_REPOSITORY ${GBENCHMARK_REPOSITORY}
        GIT_TAG ${GBENCHMARK_TAG})

    FetchContent_GetProperties(benchmark)
    if(NOT benchmark_POPULATED)
        FetchContent_Populate(benchmark)
        add_subdirectory(${benchmark_SOURCE_DIR} ${benchmark_BINARY_DIR} EXCLUDE_FROM_ALL)
    endif()
endif()

add_executable(benchmark_zlib
    benchmark_adler32.cc
    benchmark_adler32_copy.cc
    benchmark_compare256.cc
    benchmark_compare256_rle.cc
    benchmark_compress.cc
    benchmark_crc32.cc
    benchmark_main.cc
    benchmark_slidehash.cc
    benchmark_uncompress.cc
    )

target_compile_definitions(benchmark_zlib PRIVATE -DBENCHMARK_STATIC_DEFINE)
target_include_directories(benchmark_zlib PRIVATE
    ${PROJECT_SOURCE_DIR}
    ${PROJECT_BINARY_DIR}
    ${benchmark_SOURCE_DIR}/benchmark/include)

target_link_libraries(benchmark_zlib zlibstatic benchmark::benchmark)
if(WIN32)
    target_link_libraries(benchmark_zlib shlwapi)
endif()

add_test(NAME benchmark_zlib
    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:benchmark_zlib> "--benchmark_min_time=0")

if(WITH_BENCHMARK_APPS)
    option(BUILD_ALT_BENCH "Link against alternative zlib implementation" OFF)

    # Search for libpng package
    find_package(PNG QUIET)

    if(NOT PNG_FOUND)
        FetchContent_Declare(PNG
            GIT_REPOSITORY https://github.com/glennrp/libpng.git)

        FetchContent_GetProperties(PNG)
        if(NOT PNG_POPULATED)
            FetchContent_Populate(PNG)
            set(PNG_INCLUDE_DIR ${png_SOURCE_DIR})
            add_subdirectory(${png_SOURCE_DIR} ${png_BINARY_DIR})
        endif()
    endif()

    set(BENCH_APP_SRCS
        benchmark_png_encode.cc
        benchmark_png_decode.cc
        benchmark_main.cc
    )

    add_executable(benchmark_zlib_apps ${BENCH_APP_SRCS})

    if(DEFINED BUILD_ALT_BENCH)
        set(ZLIB_ALT_LIB "libz.a" CACHE FILEPATH "Optional alternative zlib implementation (defaults to stock zlib)")
        add_executable(benchmark_zlib_apps_alt ${BENCH_APP_SRCS})
        target_link_libraries(benchmark_zlib_apps_alt libpng.a ${ZLIB_ALT_LIB} benchmark::benchmark)
        target_compile_definitions(benchmark_zlib_apps_alt PRIVATE BUILD_ALT=1)
        target_include_directories(benchmark_zlib_apps_alt PRIVATE
            ${PROJECT_SOURCE_DIR}
            ${PROJECT_BINARY_DIR}
            ${PNG_INCLUDE_DIR}
            ${benchmark_SOURCE_DIR}/benchmark/include)
    endif()

    target_include_directories(benchmark_zlib_apps PRIVATE
        ${PROJECT_SOURCE_DIR}
        ${PROJECT_BINARY_DIR}
        ${PNG_INCLUDE_DIR}
        ${benchmark_SOURCE_DIR}/benchmark/include)

    # We need the static png library if we're statically linking to zlib,
    # otherwise it will resolve these things in the system provided dynamic
    # libraries (likely linked to stock zlib)
    target_link_libraries(benchmark_zlib_apps libpng.a zlibstatic benchmark::benchmark)
endif()

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=zlib-ng
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}" "${MINGW_PACKAGE_PREFIX}-${_realname}-compat")
pkgver=2.2.5
pkgrel=1
pkgdesc='zlib replacement with optimizations for next generation systems (mingw-w64)'
url='https://github.com/zlib-ng/zlib-ng'
msys2_references=(
  'anitya: 115592'
  'archlinux: zlib-ng'
  'gentoo: sys-libs/zlib-ng'
)
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
license=("spdx:Zlib")
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-cc"
)
source=("${url}/archive/refs/tags/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "0001-match-existing-zlib-naming.patch")
sha256sums=('5b3b022489f3ced82384f06db1e13ba148cbce38c7941e424d6cb414416acd18'
            '0ef20daf2831de920ded52369a74fe81e2330c184371c762552d141e3aa76554')
b2sums=('7d2907595b6e57f2739f4acea11cb317a35c4f63208d3f44b65cca0ea1ffbef89311bc839327e037b3aea78de1407d3ff025567f6768013277d0fd61e0a40210'
        '2e2744364c82b529f433433ca3c0cf1392d33bc6040bf51d0303f8d3ea789e0c6af45ee654d0d890ff9285a1124af71ca8b4c8f6dc224d21242d12ac59ff2191')

prepare() {
  cd "${_realname}-${pkgver}"
  # 1) Fix the zlib-ng naming to match the .pc file
  # 2) Make the compat naming the same as our current zlib
  patch -p1 -i "${srcdir}/0001-match-existing-zlib-naming.patch"
}

build() {
  cd "${_realname}-${pkgver}"

  declare -a extra_config
  extra_config=(
    -G Ninja
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}"
    -Wno-dev
    -DWITH_GTEST=OFF
  )

  # gcc 15.1 toolchain crashes sometimes when linking tests
  if [[ ${MSYSTEM} != CLANG* ]]; then
    extra_config+=("-DZLIB_ENABLE_TESTS=OFF")
  fi

  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  echo "Building zlib-ng"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build-static \
      -DBUILD_SHARED_LIBS=OFF \
      "${extra_config[@]}"
  cmake --build build-static

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build \
      -DBUILD_SHARED_LIBS=ON \
      "${extra_config[@]}"
  cmake --build build

  echo "Building zlib-ng-compat"
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build-compat-static \
      -DBUILD_SHARED_LIBS=OFF \
      "${extra_config[@]}" \
      -DZLIB_COMPAT=ON
  cmake --build build-compat-static

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -B build-compat \
      -DBUILD_SHARED_LIBS=ON \
      "${extra_config[@]}" \
      -DZLIB_COMPAT=ON
  cmake --build build-compat
}

check() {
  cd "${_realname}-${pkgver}"
  echo "Checking zlib-ng"
  ctest --output-on-failure --test-dir build
  echo "Checking zlib-ng-compat"
  ctest --output-on-failure --test-dir build-compat
}

package_zlib-ng() {
  cd "${_realname}-${pkgver}"

  DESTDIR="${pkgdir}" cmake --install build-static
  DESTDIR="${pkgdir}" cmake --install build
  install -Dm 644 LICENSE.md -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}"
  install -Dm 644 README.md -t "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}"
}

package_zlib-ng-compat() {
  pkgdesc+=" (zlib compat)"
  provides=("${MINGW_PACKAGE_PREFIX}-zlib")
  conflicts=("${MINGW_PACKAGE_PREFIX}-zlib")

  cd "${_realname}-${pkgver}"
  DESTDIR="${pkgdir}" cmake --install build-compat-static
  DESTDIR="${pkgdir}" cmake --install build-compat
  install -Dm 644 LICENSE.md -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}-compat"
  install -Dm 644 README.md -t "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}-compat"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
